'use strict';

/**
 * Gets zero-based index.
 * @param x an array
 * @param i index (-ve: from right) (0)
 */
function index(x, i = 0) {
    return i < 0 ? Math.max(x.length + i, 0) : Math.min(i, x.length);
}

/**
 * Exchanges two values.
 * @param x an array (updated)
 * @param i an index
 * @param j another index
 * @returns x
 */
function swap$(x, i, j) {
    var i = index(x, i), j = index(x, j);
    var t = x[i];
    x[i] = x[j];
    x[j] = t;
    return x;
}

/**
 * Exchanges two values.
 * @param x an array
 * @param i an index
 * @param j another index
 */
function swap(x, i, j) {
    return swap$(x.slice(), i, j);
}

module.exports = swap;
